#include<bits/stdc++.h>
using namespace std;
const int N=5e5+5;
const int mod=1e9+7;
int T,n,u,v,q,l,r,k,fa[N][21],dep[N];
vector<int> g[N];
void dfs(int u,int f){
	dep[u]=dep[f]+1;
	fa[u][0]=f;
	for(int i=1;i<=20;i++) fa[u][i]=fa[fa[u][i-1]][i-1];
	for(int i=0;i<g[u].size();i++){
		int v=g[u][i];
		if(v==f) continue;
		dfs(v,u);
	}
}
int query(int x,int y){
	if(dep[x]<dep[y]) swap(x,y);
	for(int i=20;i>=0;i--)
		if(dep[fa[x][i]]>=dep[y]) x=fa[x][i];
	if(x==y) return x;
	for(int i=20;i>=0;i--)
		if(fa[x][i]!=fa[y][i]){
			x=fa[x][i];
			y=fa[y][i];
		}
	return fa[x][0];
}
int main(){
	freopen("query.in","r",stdin);
	freopen("query.out","w",stdout);
	scanf("%d",&n);
	for(int i=1;i<n;i++){
		scanf("%d%d",&u,&v);
		g[u].push_back(v);
		g[v].push_back(u);
	}
	dfs(1,0);
	scanf("%d",&q);
	while(q--){
		scanf("%d%d%d",&l,&r,&k);
		int ans=0;
		for(int len=k;len<=r-l+1;len++){
			for(int i=l;i+len-1<=r;i++){
				int j=i+len-1;
				int ret=i;
				if(k>1) for(int p=i+1;p<=j;p++) ret=query(ret,p);
				ans=max(ans,dep[ret]);
			}
		}
		printf("%d\n",ans);
	}
	return 0;
} 
